
#include <util/delay.h>
//USART initialisieren
void USART0_Init (int BaudRate)
{	int ubrr0 = (F_CPU / 16 / BaudRate - 1);       	// Baudrate UART0 einstellen  
	
	UBRRH = (unsigned char)(ubrr0>>8);
	UBRRL = (unsigned char)ubrr0;
         
	UCSRC = (1<<URSEL)|(3<<UCSZ0);              		// UART0 Frame Format einstellen: 8data, 1 Stop-bit, keine Parity 
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1 << RXCIE);        	// UART0 Receiver und Transmitter einschalten
}




//Prfen, ob Zeichen empfangen wurde, dann Rckgabe, ansonsten Rckgabewert -1
int16_t USART_Receive (void)
{	//prfen, ob Zeichen empfangen wurde
	if (UCSRA & (1<<RXC))
	{	return (UDR);
	}
	else
	{	return (-1);
	}
}




//Zeichen senden
void USART_Transmit( unsigned char data )
{	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	{
		/* Put data into buffer, sends the data */
		UDR = data;
	}
}



//Gibt eine Zeichenkette mit maximal 29 Zeichen aus (realisiert mit char-Array)
void USART_String_ausgeben (char Zeichenkette [40])
{	uint8_t  i=0;
	
	while (Zeichenkette [i] != 0)
	{	USART_Transmit (Zeichenkette [i]);
		i++;
	}
}




/*
//Gibt eine Zeichenkette aus (realisiert mit Zeiger auf char)
void USART_String_ausgeben (char *Zeichenkette)
{	while (*Zeichenkette != 0)
	{	USART_Transmit (*Zeichenkette);
		Zeichenkette++;
	}
}
*/




//gibt eine positive 16-Bit-Zahl ber die serielle Schnittstelle aus
void USART_Zahl_ausgeben (uint16_t  Zahl)
{	char Zahl2 [7];
	
	itoa (Zahl, Zahl2, 10);
	USART_String_ausgeben (Zahl2);
}




//Gibt ein Bit der Variablen "Wert" aus, welches mit "Maske" maskiert wird;
//    hier darf in "Maske" nur ein Bit gesetzt sein
void USART_Bit_ausgeben (uint8_t Wert, uint8_t Maske)
{	if (Wert & Maske)
	{	USART_Transmit ('1');
	}
	else
	{	USART_Transmit ('0');
	}
}


/***Usart von mai ende***/